'use strict';

exports.__esModule = true;

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _runtime = require('../errors/runtime');

var _message = require('../errors/runtime/message');

var _message2 = _interopRequireDefault(_message);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var RawFileCompiler = function () {
    function RawFileCompiler() {
        (0, _classCallCheck3.default)(this, RawFileCompiler);
    }

    RawFileCompiler.prototype.canCompile = function canCompile(code, filename) {
        return (/\.testcafe$/.test(filename)
        );
    };

    RawFileCompiler.prototype._compileTest = function _compileTest(fixture, test) {
        var _this = this;

        test.fixture = fixture;

        test.fn = function () {
            var ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(testRun) {
                var i;
                return _regenerator2.default.wrap(function _callee$(_context) {
                    while (1) {
                        switch (_context.prev = _context.next) {
                            case 0:
                                i = 0;

                            case 1:
                                if (!(i < test.commands.length)) {
                                    _context.next = 7;
                                    break;
                                }

                                _context.next = 4;
                                return testRun.executeCommand(test.commands[i]);

                            case 4:
                                i++;
                                _context.next = 1;
                                break;

                            case 7:
                            case 'end':
                                return _context.stop();
                        }
                    }
                }, _callee, _this);
            }));
            return function (_x) {
                return ref.apply(this, arguments);
            };
        }();

        return test;
    };

    RawFileCompiler.prototype.compile = function compile(code, filename) {
        var _this2 = this;

        var data = null;

        try {
            data = JSON.parse(code);
        } catch (err) {
            throw new _runtime.GeneralError(_message2.default.cannotParseRawFile, filename, err.toString());
        }

        var fixtures = data.fixtures;
        var tests = [];

        fixtures.forEach(function (fixture) {
            fixture.path = filename;
            fixture.tests = fixture.tests.map(function (test) {
                return _this2._compileTest(fixture, test);
            });
            tests = tests.concat(fixture.tests);
        });

        return tests;
    };

    return RawFileCompiler;
}();

exports.default = RawFileCompiler;
module.exports = exports['default'];