'use strict';

exports.__esModule = true;
exports.GlobalsAPIError = exports.TestCompilationError = exports.GeneralError = undefined;

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _callsiteRecord = require('callsite-record');

var _message = require('./message');

var _message2 = _interopRequireDefault(_message);

var _stackFilter = require('../stack-filter');

var _stackFilter2 = _interopRequireDefault(_stackFilter);

var _getCallsite = require('../get-callsite');

var _getCallsite2 = _interopRequireDefault(_getCallsite);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// Utils
function getText(template) {
    for (var _len = arguments.length, args = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
        args[_key - 1] = arguments[_key];
    }

    return args.reduce(function (msg, arg) {
        return msg.replace(/{.+?}/, arg);
    }, template);
}

// Errors

var GeneralError = exports.GeneralError = function (_Error) {
    (0, _inherits3.default)(GeneralError, _Error);

    function GeneralError() {
        (0, _classCallCheck3.default)(this, GeneralError);

        var _this = (0, _possibleConstructorReturn3.default)(this, _Error.call(this, getText.apply(null, arguments)));

        Error.captureStackTrace(_this, GeneralError);

        // HACK: workaround for the `instanceof` problem
        // (see: http://stackoverflow.com/questions/33870684/why-doesnt-instanceof-work-on-instances-of-error-subclasses-under-babel-node)
        _this.constructor = GeneralError;
        return _this;
    }

    return GeneralError;
}(Error);

var TestCompilationError = exports.TestCompilationError = function (_Error2) {
    (0, _inherits3.default)(TestCompilationError, _Error2);

    function TestCompilationError(originalError) {
        (0, _classCallCheck3.default)(this, TestCompilationError);


        // NOTE: stack includes message as well.

        var _this2 = (0, _possibleConstructorReturn3.default)(this, _Error2.call(this, getText(_message2.default.cannotPrepareTestsDueToError, originalError.toString())));

        _this2.stack = getText(_message2.default.cannotPrepareTestsDueToError, originalError.stack);
        _this2.constructor = TestCompilationError;
        return _this2;
    }

    return TestCompilationError;
}(Error);

var GlobalsAPIError = exports.GlobalsAPIError = function (_Error3) {
    (0, _inherits3.default)(GlobalsAPIError, _Error3);

    function GlobalsAPIError(methodName, typeName, template) {
        (0, _classCallCheck3.default)(this, GlobalsAPIError);

        for (var _len2 = arguments.length, args = Array(_len2 > 3 ? _len2 - 3 : 0), _key2 = 3; _key2 < _len2; _key2++) {
            args[_key2 - 3] = arguments[_key2];
        }

        var _this3 = (0, _possibleConstructorReturn3.default)(this, _Error3.call(this, getText.apply(undefined, [template].concat(args))));

        _this3.callsiteRecord = (0, _getCallsite2.default)(methodName, typeName);
        _this3.constructor = GlobalsAPIError;

        // HACK: prototype properties don't work with built-in subclasses
        // (see: http://stackoverflow.com/questions/33870684/why-doesnt-instanceof-work-on-instances-of-error-subclasses-under-babel-node)
        Object.defineProperty(_this3, 'stack', {
            get: function get() {
                return GlobalsAPIError._createStack(_this3.message, _this3.callsiteRecord, _callsiteRecord.renderers.noColor);
            }
        });

        Object.defineProperty(_this3, 'coloredStack', {
            get: function get() {
                return GlobalsAPIError._createStack(_this3.message, _this3.callsiteRecord, _callsiteRecord.renderers.default);
            }
        });
        return _this3;
    }

    GlobalsAPIError._createStack = function _createStack(message, callsiteRecord, renderer) {
        return message + '\n\n' + callsiteRecord.renderSync({ renderer: renderer, stackFilter: _stackFilter2.default });
    };

    return GlobalsAPIError;
}(Error);