'use strict';

exports.__esModule = true;
exports.default = stackFilter;

var _path = require('path');

var _lodash = require('lodash');

var BABEL = require.resolve('babel-core');
var BABEL_MODULES_DIR = BABEL.replace(new RegExp('^(.*' + (0, _lodash.escapeRegExp)(_path.sep) + 'node_modules' + (0, _lodash.escapeRegExp)(_path.sep) + ')(.*)'), '$1');

var BABEL_RELATED = BABEL_MODULES_DIR + 'babel-';
var BABYLON = BABEL_MODULES_DIR + 'babylon' + _path.sep;
var CORE_JS = BABEL_MODULES_DIR + 'core-js' + _path.sep;

var TESTCAFE_LIB = (0, _path.join)(__dirname, '../');
var TESTCAFE_BIN = (0, _path.join)(__dirname, '../../bin');

var INTERNAL = 'internal/';

function stackFilter(frame) {
    var filename = frame.getFileName();

    // NOTE: filter node, Babel and TestCafe internals
    return filename.indexOf(_path.sep) > -1 && filename.indexOf(INTERNAL) !== 0 && filename.indexOf(TESTCAFE_LIB) !== 0 && filename.indexOf(TESTCAFE_BIN) !== 0 && filename.indexOf(BABEL_RELATED) !== 0 && filename.indexOf(BABYLON) !== 0 && filename.indexOf(CORE_JS) !== 0;
}
module.exports = exports['default'];