'use strict';

exports.__esModule = true;

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _pinkie = require('pinkie');

var _pinkie2 = _interopRequireDefault(_pinkie);

var _testcafeHammerhead = require('testcafe-hammerhead');

var _commands = require('./commands');

var _clientMessages = require('./client-messages');

var _clientMessages2 = _interopRequireDefault(_clientMessages);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var TestRun = function (_Session) {
    (0, _inherits3.default)(TestRun, _Session);

    function TestRun(test, browserConnection, screenshotCapturer, opts) {
        (0, _classCallCheck3.default)(this, TestRun);

        var uploadsRoot = _path2.default.dirname(test.fixture.path);

        var _this = (0, _possibleConstructorReturn3.default)(this, _Session.call(this, uploadsRoot));

        _this.opts = opts;
        _this.test = test;
        _this.browserConnection = browserConnection;
        _this.screenshotCapturer = screenshotCapturer;

        _this.started = false;
        _this.pendingCommand = null;
        _this.pendingRequest = null;
        _this.pendingJsError = null;

        _this.errs = [];
        return _this;
    }

    TestRun.prototype._getPayloadScript = function _getPayloadScript() {
        // TODO
    };

    TestRun.prototype._getIframePayloadScript = function _getIframePayloadScript() {
        // TODO
    };

    TestRun.prototype._start = function () {
        var ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee() {
            return _regenerator2.default.wrap(function _callee$(_context) {
                while (1) {
                    switch (_context.prev = _context.next) {
                        case 0:
                            this.started = true;

                            _context.prev = 1;
                            _context.next = 4;
                            return this.test.fn(this);

                        case 4:
                            _context.next = 9;
                            break;

                        case 6:
                            _context.prev = 6;
                            _context.t0 = _context['catch'](1);

                            this.errs.push(_context.t0);

                        case 9:
                            _context.prev = 9;

                            this._done();
                            return _context.finish(9);

                        case 12:
                        case 'end':
                            return _context.stop();
                    }
                }
            }, _callee, this, [[1, 6, 9, 12]]);
        }));

        function _start() {
            return ref.apply(this, arguments);
        }

        return _start;
    }();

    TestRun.prototype._done = function () {
        var ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee2() {
            return _regenerator2.default.wrap(function _callee2$(_context2) {
                while (1) {
                    switch (_context2.prev = _context2.next) {
                        case 0:
                            if (this.pendingJsError) {
                                this.errs.push(this.pendingJsError);
                                this.pendingJsError = null;
                            }

                            _context2.next = 3;
                            return this.executeCommand((0, _commands.createDoneCommand)());

                        case 3:
                            this.emit('done');

                        case 4:
                        case 'end':
                            return _context2.stop();
                    }
                }
            }, _callee2, this);
        }));

        function _done() {
            return ref.apply(this, arguments);
        }

        return _done;
    }();

    TestRun.prototype._resolvePendingCommand = function _resolvePendingCommand() {
        this.pendingCommand.resolve();
        this.pendingCommand = null;
    };

    TestRun.prototype._rejectPendingCommand = function _rejectPendingCommand(err) {
        this.pendingCommand.reject(err);
        this.pendingCommand = null;
    };

    TestRun.prototype._resolvePendingRequest = function _resolvePendingRequest(command) {
        this.pendingRequest.resolve(command);
        this.pendingRequest = null;
    };

    TestRun.prototype.getAuthCredentials = function getAuthCredentials() {
        // TODO
    };

    TestRun.prototype.handleFileDownload = function handleFileDownload() {
        // TODO
    };

    TestRun.prototype.handlePageError = function handlePageError() {
        // TODO
    };

    TestRun.prototype.executeCommand = function executeCommand(command) {
        var _this2 = this;

        if (this.pendingCommand) throw new Error('An attempt to execute a command when a previous command is still being executed was detected.');

        var pendingJsError = this.pendingJsError;

        if (pendingJsError) {
            this.pendingJsError = null;
            return _pinkie2.default.reject(pendingJsError);
        }

        if (this.pendingRequest) this._resolvePendingRequest(command);

        return new _pinkie2.default(function (resolve, reject) {
            return _this2.pendingCommand = { command: command, resolve: resolve, reject: reject };
        });
    };

    return TestRun;
}(_testcafeHammerhead.Session);

// Service message handlers


exports.default = TestRun;
var ServiceMessages = TestRun.prototype;

ServiceMessages[_clientMessages2.default.ready] = function (commandResult) {
    var _this3 = this;

    this.pendingRequest = null;

    if (!this.started) this._start();

    if (this.pendingCommand) {
        if (commandResult) {
            if (commandResult.failed) this._rejectPendingCommand(commandResult.err);else this._resolvePendingCommand();
        } else return _pinkie2.default.resolve(this.pendingCommand.command);
    }

    return new _pinkie2.default(function (resolve, reject) {
        return _this3.pendingRequest = { resolve: resolve, reject: reject };
    });
};

ServiceMessages[_clientMessages2.default.jsError] = function (msg) {
    if (this.pendingCommand) this._rejectPendingCommand(msg.err);else this.pendingJsError = msg.err;
};

ServiceMessages[_clientMessages2.default.done] = function () {
    this.pendingCommand.resolve();
};
module.exports = exports['default'];